set more off
sysuse cancer, clear 
gen drug2=drug==2
gen drug3=drug==3
global xvars "drug2 drug3 age" 
mata: 
mata clear
function myprobit_d2(transmorphic M, real scalar todo,
 real rowvector b, fv, g, H) 
{ 
 y = moptimize_util_depvar(M, 1) 
 xb = moptimize_util_xb(M, b, 1)
 N = rows(y)
 q = 2*y - J(N,1,1)
 Sigma = ln(normal(q:*xb))
 fv =  moptimize_util_sum(M, Sigma)   
 if (todo>0) { 
  d = (q:*normalden(xb)):/normal(q:*xb) 
  g =  moptimize_util_vecsum(M, 1, d, fv)
 } 
 if (todo>1) { 
  Dd = J(N,1,-1):*d:*(d+xb)
  H = moptimize_util_matsum(M, 1, 1, Dd, fv) 
 } 
} 
M = moptimize_init()
moptimize_init_evaluator(M, &myprobit_d2())
moptimize_init_evaluatortype(M, "d2")
moptimize_init_depvar(M, 1, "died")
moptimize_init_eq_indepvars(M, 1, "drug2 drug3 age")
moptimize(M)
moptimize_result_display(M)
end

/* Run the probit with Stata*/

probit died drug2 drug3 age
