/* probit by ML gf1 with moptimize */
set more off
use http://www.stata-press.com/data/r12/union
global xvars "age grade not_smsa year south" 
mata: 
mata clear
function myprobit_gf1(transmorphic M, real scalar todo,
 real rowvector b, fv, g, H) 
{ 
 y = moptimize_util_depvar(M, 1) 
 xb = moptimize_util_xb(M, b, 1)
 N = rows(y)
 q = 2*y - J(N,1,1)
 fv = ln(normal(q:*xb))
 if (todo>0) { 
  st_view(X,.,tokens(st_global("xvars"))) 
  one = J(rows(X),1,1) 
  X = (X,one) 
  g = (q:*normalden(xb)):/normal(q:*xb) 
  g = g:*X
 } 
} 
M = moptimize_init()
moptimize_init_evaluator(M, &myprobit_gf1())
moptimize_init_evaluatortype(M, "gf1")
moptimize_init_vcetype(M, "robust")
moptimize_init_cluster(M, "idcode")
moptimize_init_depvar(M, 1, "union")
moptimize_init_eq_indepvars(M, 1, "$xvars")
moptimize(M)
moptimize_result_display(M)
end
 
/* Run the probit with Stata*/

probit union $xvars, vce(cluster idcode)

